%option noyywrap 

%{
#define SIZEBUF 4
#define INCR_CHARNO() (charno+=yyleng)
#define AFFICHER(text) (printf("%s \t\t -- " text "\n",yytext))


  void voir_si_err(void);
  void set_err(void);
    
  int lineno=1;
  int charno=0;
  int err=0;
  int start_err=0;

  char err_buffer[SIZEBUF];
  int buffer_left=SIZEBUF-1;
%}



CHIFFRE [0-9]
LETTRE  [a-zA-Z]
OP      [+=]
PAROUV  "("
PARFER  ")"
IDENT   {LETTRE}({CHIFFRE}|{LETTRE})*
NOMBRE  {CHIFFRE}+
BLANCS  [ \t]+

%%

\n  {
  voir_si_err();
  charno=0;
  lineno++;
}

{BLANCS}   {
  voir_si_err();
  INCR_CHARNO();
}

"let"|"in"|"if"    { 
  voir_si_err();
  INCR_CHARNO(); 
  AFFICHER("Mot clef");
}

"true"|"false" {
  voir_si_err(); 
  INCR_CHARNO();
  AFFICHER("Mot cle, constante booleenne");
}

{IDENT}   {
  voir_si_err();
  INCR_CHARNO();
  AFFICHER("Identificateur");
}

{NOMBRE}  {
  voir_si_err();
  INCR_CHARNO();
  AFFICHER("Nombre");
}

{OP}      {
  voir_si_err();
  INCR_CHARNO();
  AFFICHER("Operateur");
}

{PAROUV}     {
  voir_si_err();
  INCR_CHARNO();
  AFFICHER("Parenthese ouverte");
}

{PARFER}     {
  voir_si_err();
  INCR_CHARNO();
  AFFICHER("Parenthese fermee");
}

.          {
  INCR_CHARNO();
  set_err();}

%%

void
voir_si_err(void)
{
  if(err==1) 
    {
      if(err_buffer[0] != 0)	{
	printf("Ligne %d, caracteres %d-%d :\n"
	       "Suite des symboles non reconnus : %s\n",
	       lineno,
	       start_err,charno,
	       err_buffer);
      }

      err=0;
      strcpy(err_buffer,"");
      buffer_left=SIZEBUF-1;
    }
}  

void
set_err(void)
{
  if (err==0)
    { 
      start_err=charno;
      err=1;
    }

  strncat(err_buffer,yytext,buffer_left);
  /* On copie un caractere  la fois */

  buffer_left--; 

  if(buffer_left == 0)
    {
      fprintf(stderr,"Erreur trop long : %s\n",err_buffer);
      strcpy(err_buffer,"");
      buffer_left=SIZEBUF-1;
    }
}



int 
main(int argc, char* argv[])
{
  strcpy(err_buffer,"");
  
  if ( argc > 1 ) {
    
    yyin = fopen( argv[1], "r" );
    if(yyin == NULL) {
      fprintf(stderr,"Erreur : %s.\n",strerror(errno));
      exit(EXIT_FAILURE);
    }
    
    yylex();
    fclose(yyin);
  }
  exit(EXIT_SUCCESS);
}


