%{
  void afficher(char *);
%}

%option noyywrap 
%option yylineno

chiffre [0-9]
lettre  [a-zA-Z]
op      [+*=]
ident   {lettre}({chiffre}|{lettre})*
nombre  {chiffre}+
blancs  [ \t\n]+

%%

{blancs}   {/* Rien a faire */}

let|in|if|then|else    {afficher("Mot clef");}
"("|")" {afficher("Symbole (parenthese)");}
{ident}   {afficher("Identificateur");}
{nombre}  {afficher("Nombre");}
{op}      {afficher("Operateur");}

.          {fprintf(stderr,"Symbole non reconnu a la ligne %d.\n",yylineno);}

%%

void 
afficher(char *str)
{
printf("%s \t\t: %s.\n",yytext,str);
}

int 
main(int argc, char* argv[])
{
  if ( argc > 1 ) {
    
    yyin = fopen( argv[1], "r" );
    if(yyin == NULL) {
      fprintf(stderr,"Erreur : %s.\n",strerror(errno));
      exit(EXIT_FAILURE);
    }
    
    yylex();
    fclose(yyin);
  }
  exit(EXIT_SUCCESS);
}


