%{
  void afficher(char *);
  void incr_charno(void);
  int lineno=1,charno=0;
%}

%option noyywrap 


CHIFFRE [0-9]
LETTRE  [a-zA-Z]
OP      [+=]
PAROUV  "("
PARFER  ")"
IDENT   {LETTRE}({CHIFFRE}|{LETTRE})*
NOMBRE  {CHIFFRE}+
BLANCS  [ \t]+

%%

\n         {charno=0;lineno++;}
{BLANCS}   {incr_charno();}
"let"|"in"|"if"    {incr_charno();afficher("Mot clef");}
"true" | "false" {incr_charno();afficher("Mot cle, constante booleenne");}
{IDENT}   {incr_charno();afficher("Identificateur");}
{NOMBRE}  {incr_charno();afficher("Nombre");}
{OP}      {incr_charno();afficher("Operateur");}
{PAROUV}     {incr_charno();afficher("Parenthese ouverte");}
{PARFER}     {incr_charno();afficher("Parenthese fermee");}

.          {incr_charno();fprintf(stderr,
		    "Symbole non reconnu"
		    " a la ligne %d, caractere %d : \"%s\"\n",
		    lineno,charno,yytext);}
%%
void 
incr_charno(void)
{
  charno+=yyleng;
}

void 
afficher(char *str)
{
  printf("%s \t\t: %s.\n",yytext,str);
}

int 
main(int argc, char* argv[])
{
  if ( argc > 1 ) {
    
    yyin = fopen( argv[1], "r" );
    if(yyin == NULL) {
      fprintf(stderr,"Erreur : %s.\n",strerror(errno));
      exit(EXIT_FAILURE);
    }
    
    yylex();
    fclose(yyin);
  }
  exit(EXIT_SUCCESS);
}


